# Enumerations

Enumerations are sum types.

## Example: The Option Type

```
given A
enum Option
    given A
    record Some (value: A)
    object None
end enum

given A
fn some: (a: A) => Some[A]
    a => Some (a)
end fn
```

## Example: The Either Type

TODO: Describe import behavior! Does importing Either import Left/Right?

```
given L, R
enum Either
    given L
    record Left (value: L)

    given R
    record Right (value: R)

given L
fn left: (left: L) => Either<L, Nothing> := l => Left(l)
end fn

given R
fn right: (right: R) => Either<Nothing, R> := Right(r)
end fn
```
